<?php

namespace Teknisa\PLA\Modules\Ciclo\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\Environment;
use TecFood\Services\User as UserService;


class pla09900ServicoCicloController extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $dataSourceName = "cardciclo";
    protected $connection;

    public function __construct($connection){
        
        $this->connection = $connection;
    }
    
    public function verificarInsercao(DTO\Request $request, DTO\Response $response){
        
        $row = $request->getRow();
        
        $params = array(
            "P_CDFILIAL" => $row["CDFILIAL"],
            "P_CDSERVFILI" => $row["CDSERVFILI"],
            "P_MESCICLO" => $row["DTINICICLO"]
        );
        
        $sql = "SELECT CDCARDCICLO, CDFILIAL, CDSERVFILI, DTINICICLO FROM SERVCARDCICLO WHERE CDFILIAL = :P_CDFILIAL AND CDSERVFILI = :P_CDSERVFILI AND DTINICICLO = TO_DATE(:P_MESCICLO, 'MM/YYYY')";
        
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            $response->addDataSet(new DataSet('EXISTE', $result));
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function saveRegister(DTO\Request $request, DTO\Response $response){
        
        $row = $request->getRow();
        
        $params = array(
            "CDFILIAL"    => $row["CDFILIAL"],
            "CDSERVFILI"  => $row["CDSERVFILI"],
            "DTINICICLO"  => $row["DTINICICLO"],
            "NRINICICLO"  => $row["NRINICICLO"],
            "CDCARDCICLO" => $row["CDCARDCICLO"],
            "CDPADCICLO"  => $row["CDPADCICLO"]
        );
        
        $sqlInsert = "INSERT INTO SERVCARDCICLO (CDFILIAL, CDSERVFILI, DTINICICLO, NRINICICLO, CDCARDCICLO, CDPADCICLO) VALUES (:CDFILIAL, :CDSERVFILI, TO_DATE(:DTINICICLO, 'MM/YYYY'), :NRINICICLO, :CDCARDCICLO, :CDPADCICLO)";
        
        try {
            $std = $this->connection->prepare($sqlInsert);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
}